'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.DEFAULT_STATE = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _immutable = require('immutable');

var _reactCmf = require('react-cmf');

var _ack = require('../../actions/ack');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DEFAULT_STATE = exports.DEFAULT_STATE = new _immutable.Map({});

/**
 * {
		type: 'ACK_ADD_CONTEXT',
		requestId: '123',
		data: { foo: 'bar' },
		actionCreator: 'dataset:fetchAll'
	}
 {
	 type: 'ACK_RECEIVE_MESSAGE',
	 requestId: '123',
 }

 */

var ACKDispatcher = function (_React$Component) {
	_inherits(ACKDispatcher, _React$Component);

	function ACKDispatcher(props, context) {
		_classCallCheck(this, ACKDispatcher);

		var _this = _possibleConstructorReturn(this, (ACKDispatcher.__proto__ || Object.getPrototypeOf(ACKDispatcher)).call(this, props, context));

		_this.dispatchAndUpdateAck = _this.dispatchAndUpdateAck.bind(_this);
		_this.processACK = _this.processACK.bind(_this);
		_this.state = { dispatchedAck: [] };
		return _this;
	}

	_createClass(ACKDispatcher, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			if (this.props.acks) {
				this.processACK(this.props.acks);
			}
		}
	}, {
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(nextProps) {
			if (nextProps.acks) {
				this.processACK(nextProps.acks);
			}
		}
	}, {
		key: 'shouldComponentUpdate',
		value: function shouldComponentUpdate(nextProps) {
			return this.props.acks !== nextProps.acks;
		}
	}, {
		key: 'dispatchAndUpdateAck',
		value: function dispatchAndUpdateAck(actionCreator, data, requestId) {
			var action = _reactCmf.api.action.getActionCreatorFunction(this.context, actionCreator)({}, data, this.context);
			action.ack = (0, _ack.deleteACK)(null, { requestId: requestId });
			this.props.dispatch(action);
			this.setState(function (oldState) {
				if (oldState.dispatchedAck.includes(requestId)) {
					return oldState;
				}
				return { dispatchedAck: oldState.dispatchedAck.concat([requestId]) };
			});
		}
	}, {
		key: 'processACK',
		value: function processACK(acks) {
			var _this2 = this;

			acks.filter(function (ack) {
				return ack.get('received') === true && ack.get('actionCreator');
			}).forEach(function (ack, requestId) {
				var data = ack.get('data');
				if (data === undefined) {
					data = {};
				}
				_this2.dispatchAndUpdateAck(ack.get('actionCreator'), data, requestId);
			});
		}
	}, {
		key: 'render',
		value: function render() {
			// eslint-disable-line class-methods-use-this
			return null;
		}
	}]);

	return ACKDispatcher;
}(_react2.default.Component);

ACKDispatcher.displayName = 'Container(ACKDispatcher)';
ACKDispatcher.propTypes = _extends({
	acks: _react.PropTypes.object }, _reactCmf.componentState.propTypes);
ACKDispatcher.contextTypes = {
	registry: _react.PropTypes.object,
	store: _react.PropTypes.object,
	router: _react.PropTypes.object
};
exports.default = ACKDispatcher;