'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = ackReducer;
exports.ackProcessed = ackProcessed;

var _immutable = require('immutable');

var _index = require('../constants/index');

var DEFAULT_STATE = new _immutable.Map({});

/**
 * ackReducer
 * @param  {Object} state  redux
 * @param  {Object} action redux
 * @return {Object}        new state
 */
function ackReducer() {
	var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DEFAULT_STATE;
	var action = arguments[1];

	switch (action.type) {
		case _index.ACK_ADD_CONTEXT:
			return state.setIn([action.requestId, 'data'], action.data).setIn([action.requestId, 'actionCreator'], action.actionCreator);
		case _index.ACK_RECEIVE_MESSAGE:
			return state.setIn([action.requestId, 'received'], true);
		case _index.ACK_DELETE:
			return state.remove(action.requestId);
		default:
			return state;
	}
}

function ackProcessed(state, action) {
	if (action.ack) {
		var newState = Object.assign({}, state, {
			ack: ackReducer(state.ack, action.ack)
		});
		return newState;
	}
	return state;
}